package es.kauron.jstudy.controller;

import es.kauron.jstudy.model.TestItem;
import javafx.beans.property.BooleanProperty;
import javafx.collections.ObservableList;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.Node;
import javafx.scene.control.TextField;
import javafx.stage.Stage;

import java.net.URL;
import java.util.ResourceBundle;

public class EditController implements Initializable {
    @FXML
    private TextField questionText, answerText;
    private ObservableList<TestItem> list;
    private int index;
    private TestItem item;
    private BooleanProperty saved;
    private String originalQuestion, originalAnswer;

    @Override
    public void initialize(URL url, ResourceBundle rb) {
    }

    void setList(ObservableList<TestItem> list, BooleanProperty saved) {
        setList(list, -1, saved);
    }

    void setList(ObservableList<TestItem> list, int index, BooleanProperty saved) {
        this.list = list; // Save attributes correctly
        this.index = index;
        this.saved = saved;
        // Copy current values to textViews
        // and initialize item to hold the current object in edition
        if (index < 0) item = new TestItem("","");
        else {
            questionText.setText(list.get(index).getQuestion());
            answerText.setText(list.get(index).getAnswer());
            item = new TestItem(list.get(index));
        }
        originalQuestion = questionText.getText();
        originalAnswer   = answerText.getText();
        item.questionProperty().bind(questionText.textProperty());
        item.answerProperty().bind(answerText.textProperty());
    }

    @FXML
    protected void onSaveAction(ActionEvent event) {
        if (index < 0) {
            if (!item.isValid())
                return;
            list.add(item);
        } else {
            list.set(index, item);
        }
        if (!originalQuestion.equals(item.getQuestion()) || !originalAnswer.equals(item.getAnswer())) saved.set(false);
        onCancelAction(event);
    }

    @FXML
    protected void onCancelAction(ActionEvent event) {
        ((Stage) ((Node) event.getSource())
                .getScene().getWindow())
                .close();
    }
}
